//----------------------------------------------------------------------------//
//  ReadMe.h
// 「iPhoneアプリ開発塾」挑戦サンプルアプリ「サルりす」について
//  SARURIS
//  Created by Takashi Kawasaki.
//  Creation date    2012/1/27
//  Last update date 2012/5/18
//  Copyright MaiWay Co., Ltd. All rights reserved.
//----------------------------------------------------------------------------//

はじめまして。サルりすのソースコードへようこそ！
このサルりすソースコードは、iPhoneアプリ開発塾をお買い上げいただいた方にのみご利用いただける、
落ち物系ゲームアプリの雛形となっております。本の次のサンプルとして、ガンガン挑戦してみてください！


ご利用いただくにあたり、いくつか説明させていただきます。
アプリ自体は単なるプログラムの塊なのですが、各種項目の内容はワタシが勝手に決めていますので、
「ワタシにしかわからない項目」というものが多々含まれているわけです。
意味不明、ということになる可能性がありますので、まずはこちらをお読みください。

【処理の大まかな流れ】
このサルりすは落ち物ゲームですので、ブロックが落ちてきます。
その様子を作るときに、実際に各オブジェクトの位置をズラすと大変そうですので、
あらかじめ必要な範囲（マス目）に、透明なブロックを敷き詰めました。

その上で、同じ数の行・列を持つマス目を配列で再現し、配列を下方向にドンドン入れ替えていきます。
入れ替えるたびに配列の中の値をチェック、透明だったブロックに対応する画像を表示することで、あら不思議。
ブロックが落ちて行っているように見えるアプリになるわけです。

ブロックが揃っていることをチェックするのも配列で管理。
クモの巣や台風のような特殊効果の発生場所も配列で管理しています。
実際のブロックは「おまけ」みたいなものですね。

配列上、一番上のブロックスタート地点に特定の値があった場合、ゲームオーバーとなります。

【配列について】
ということで、全てのキモになる配列ですが、
1つのマス目に対して、2桁の値を保持しています。
「10」とか「99」とか、そういう感じです。

で、この2桁の各々の値が、それぞれ意味を持っています。
------------------
10の位はマスに対するキャラクターを表す:
（0:空白 1:マイキー 2:サリー 3:マックス 4:ピッポ 5:レオ 6:ネッティー 7:マイキーSP※ 8:サリーSP※ 9:消しインジケーター）
※SPとは、レインボーのキャラクターのことです

1の位はそのマスの状態を表す:
（0:空白 1:落下対象（親）2:落下対象（子）3:クモの巣 4:台風 8:消し予約 9:停止状態）
------------------
例えば、「00」の場合は、空白x空白ですので、「空白」になります。
同様に、「11」の場合は、マイキーx落下対象ですので、「落下可能な状態のマイキー」ということになります。
落下対象に「親」と「子」があるのは、2つセットで落ちてくるブロックの、どちら側なのか、ということを判別するためのしるしです。

1の位にややいろいろと詰め込んでいるのは、3桁にはしたくなかったワタシの強引な処置の残骸です。
ホントすいません...。

同様に本体の中にもかなり強引な処理を行なっている場合があります。

「オレならこうするな、アタシならこんな感じ」
そんな風に、読みやすいコードにドンドン直してみてください。
サルりすを完成させるのは、アナタなのです！（と、言ってみたり...）

【本との違いについて】
作成のタイミングやら機能実装の内容やら、様々な問題で本に掲載しているコードと違う書き方をしているものがあります。
アニメーションについて
・本では「animateWithDuration」だが、サルりすでは「commitAnimations」を使っている（GameViewController.m）
加速度センサーについて
・本では「CoreMotion」だが、サルりすでは「UIAccelerometer」を使っている（GameViewController.m）
本のほうが最新ですので、覚えるのであれば本のやり方がオススメです。


さて！長々とした説明はこのくらいにして、動かしてみましょう！
iPhoneアプリ開発の楽しさを、存分に味わってくださいね！


【サルりすについて】
開発 カワサキタカシ
イラスト 未来さん
音楽 ACT3さん
英訳 TAKさん
企画・広報 ワタナベさん（技術評論社）
スペシャルサンクス 全てのサルできストのみなさま

【開発前提】
MacOS X 10.7.4,iOS 5.1をベースとしたXcode4.3により開発しています。

【中に含まれるもののうち、チェックしたほうがいいもの】
ReadMe.h                    - このファイルです。取扱説明書になっています。
CONST.h                     - プログラムの中で使用する各種定数です。設定の調整用として使います。
MainStoryboard_iPhone/iPad.storyboard   - ストーリーボードです。今回はユニバーサルバイナリなので、iPhone/iPad両方あります。
AppDelegate.h/.m            - アプリデリゲートです。ウィンドウやユーザーデフォルトの初期値等をセットアップしてくれます。
MenuViewController.h/.m		- メニュー画面です。以下3つの画面へのリンクボタンがあります。
GameViewController.h/.m     - ゲーム画面です。この中にサルりすゲームが詰まっています。
RankingViewController.h/.m  - ランキング画面です。自分のスコアの表示とゲームセンターへのリンクがあります。
SettingViewController.h/.m  - 設定画面です。ユーザー側で変更可能な項目をまとめています。
Image Files                 - 各種画像ファイルです。
Sound Files                 - 各種音楽ファイルです。
InfoPlist.strings           - Info.plistの上書き用データです。今回はアプリ名の日英対応を行っています。
Localizable.strings         - アプリ内の文字列や画像パスの翻訳ファイルです。こちらも日英対応です。

【バージョン管理】
1.0 - 初版
1.1 - ゲームセンター対応版

【お問い合わせ】
[サルでき.jp] http://sarudeki.jp/ 
[技術評論社] http://gihyo.jp/book/
〒 162-0846
東京都新宿区市谷左内町 21-13 株式会社技術評論社 書籍編集部
「iPhone アプリ開発塾」係  FAX 03-3513-6167