//----------------------------------------------------------------------------//
//  MenuViewController.m
//  SARURIS
//  Created by Takashi Kawasaki.
//  Creation date    2012/1/27
//  Last update date 2012/5/18
//  Copyright MaiWay Co., Ltd. All rights reserved.
//----------------------------------------------------------------------------//

//-------------------------------------------------//
// M-1 ヘッダーファイルをインポートしようブロック
//-------------------------------------------------//
#import "MenuViewController.h"
#import "CONST.h"

#pragma mark -
#pragma mark M-2 クラスとアクセサメソッドの実装をしようブロック
//-------------------------------------------------//
// M-2 クラスとアクセサメソッドの実装をしようブロック
//-------------------------------------------------//

@implementation MenuViewController
// （アクセサメソッドはここでは不使用）

#pragma mark -
#pragma mark M-3 まずはここに処理を書こうブロック
//-------------------------------------------------//
// M-3 まずはここに処理を書こうブロック
//-------------------------------------------------//

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    // ビューの設定をまとめて行うメソッドを呼び出します。
    [self configureView];
}

#pragma mark -
#pragma mark M-4 ビューを好きなだけイジろうブロック
//-------------------------------------------------//
// M-4 ビューを好きなだけイジろうブロック
//-------------------------------------------------//

- (void)configureView
{
    // ユーザーデフォルトから保存データを読み出します。
	NSUserDefaults *userDefaults   = [NSUserDefaults standardUserDefaults];
    float audioVolume              = [userDefaults floatForKey:@"audioVolume"];
    
    // iPhone/iPad共通設定
    // スタートボタン（画面の遷移はstoryboardで設定） 
    [startButton_ setTitle:@"" forState:UIControlStateNormal];
	startButton_.backgroundColor = [UIColor clearColor];
    [startButton_ addTarget:self action:@selector(playSound:) forControlEvents:UIControlEventTouchUpInside];
    
    // ランキングボタン（画面の遷移はstoryboardで設定） 
    [rankingButton_ setTitle:@"" forState:UIControlStateNormal];
	rankingButton_.backgroundColor = [UIColor clearColor];
    [rankingButton_ addTarget:self action:@selector(playSound:) forControlEvents:UIControlEventTouchUpInside];
    
    // 設定ボタン（画面の遷移はstoryboardで設定）
    [settingButton_ setTitle:@"" forState:UIControlStateNormal];
	settingButton_.backgroundColor = [UIColor clearColor];
    [settingButton_ addTarget:self action:@selector(playSound:) forControlEvents:UIControlEventTouchUpInside];
    
    // iPhone固有の設定
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPhone){
        // 背景イメージ
        bgImgView_              = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"bg_top.png"]];
        bgImgView_.frame        = CGRectMake(0.0, 0.0, 320.0, 480.0);
        
        // スタートボタン
        [startButton_ setImage:[UIImage imageNamed:@"btn_start_nomal.png"] forState:UIControlStateNormal];
        [startButton_ setImage:[UIImage imageNamed:@"btn_start_down.png"] forState:UIControlStateHighlighted];
        startButton_.frame      = CGRectMake(70.0, 234.0, 200.0, 66.0);
        
        // ランキングボタン
        [rankingButton_ setImage:[UIImage imageNamed:@"btn_ranking_nomal.png"] forState:UIControlStateNormal];
        [rankingButton_ setImage:[UIImage imageNamed:@"btn_ranking_down.png"] forState:UIControlStateHighlighted];
        rankingButton_.frame    = CGRectMake(54.0, 300.0, 200.0, 66.0);
        
        [settingButton_ setImage:[UIImage imageNamed:@"btn_setting_nomal.png"] forState:UIControlStateNormal];
        [settingButton_ setImage:[UIImage imageNamed:@"btn_setting_down.png"] forState:UIControlStateHighlighted];
        settingButton_.frame    = CGRectMake(70.0, 370.0, 200.0, 66.0);
	// iPad用固有の設定
    }else {
        // 背景イメージ
        bgImgView_              = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"bg_top_ipad.png"]];
        bgImgView_.frame        = CGRectMake(.0, 0.0, 768.0, 1024.0);
        
        // スタートボタン
        [startButton_ setImage:[UIImage imageNamed:@"btn_start_nomal_ipad.png"] forState:UIControlStateNormal];
        [startButton_ setImage:[UIImage imageNamed:@"btn_start_down_ipad.png"] forState:UIControlStateHighlighted];
        startButton_.frame      = CGRectMake(195.0, 491.4, 420.0, 138.6);
        
        // ランキングボタン
        [rankingButton_ setImage:[UIImage imageNamed:@"btn_ranking_nomal_ipad.png"] forState:UIControlStateNormal];
        [rankingButton_ setImage:[UIImage imageNamed:@"btn_ranking_down_ipad.png"] forState:UIControlStateHighlighted];
        rankingButton_.frame    = CGRectMake(161.4, 630.0, 420.0, 138.6);
        
        // 設定ボタン
        [settingButton_ setImage:[UIImage imageNamed:@"btn_setting_nomal_ipad.png"] forState:UIControlStateNormal];
        [settingButton_ setImage:[UIImage imageNamed:@"btn_setting_down_ipad.png"] forState:UIControlStateHighlighted];
        settingButton_.frame    = CGRectMake(195.0, 777.0, 420.0, 138.6);
	}
    
    // 背景をビューに加えます。（storyboard上の各ボタンの下に設置）
    [self.view insertSubview:bgImgView_ atIndex:0];
    
    // ボタン押下時の効果音を準備します。
	NSString *soundPath         = [[NSBundle mainBundle] pathForResource:@"se_select" ofType:@"wav"];
	NSURL *soundUrl             = [NSURL fileURLWithPath:soundPath];
    AudioServicesCreateSystemSoundID((__bridge CFURLRef)soundUrl, &gameSound_);
    
    // BGMの再生を準備します。（繰り返し設定）
    NSString *audioPath         = [[NSBundle mainBundle] pathForResource:@"bgm_menu" ofType:@"mp3"];  
    NSURL *audioUrl             = [NSURL fileURLWithPath:audioPath];
    gameAudio_                  = [[AVAudioPlayer alloc] initWithContentsOfURL:audioUrl error:nil]; 
    gameAudio_.currentTime      = 0.0;
    gameAudio_.volume           = audioVolume;
    gameAudio_.numberOfLoops    = -1;  
    [gameAudio_ prepareToPlay];
}

#pragma mark -
#pragma mark M-5 オリジナルメソッドを実装しようブロック
//-------------------------------------------------//
// M-5 オリジナルメソッドを実装しようブロック
//-------------------------------------------------//

// BGM再生ボタンが押された時のアクションを設定します。
- (void)playSound:(id)sender
{
    // 音を鳴らす
	AudioServicesPlaySystemSound(gameSound_);
}

#pragma mark -
#pragma mark M-6 デリゲートメソッドをイジろうブロック
//-------------------------------------------------//
// M-6 デリゲートメソッドをイジろうブロック
//-------------------------------------------------//

#pragma mark -
#pragma mark M-6.1 ビューのあれこれをイジろうブロック
//------------------------------------------//
// M-6.1 ビューのあれこれをイジろうブロック
//------------------------------------------//

// ビューが表示される「前」にこの処理が呼ばれます。
- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    
    // BGMの再生
    [gameAudio_ play];
}

// ビューが表示された「後」にこの処理が呼ばれます。
- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

// ビューが非表示にされる「前」にこの処理が呼び出されます。
- (void)viewWillDisappear:(BOOL)animated
{
	[super viewWillDisappear:animated];
    
    // BGMを止めて初期化
    if ([gameAudio_ isPlaying]) {
        [gameAudio_ stop];
        gameAudio_.currentTime = 0.0;
    }
}

// ビューが非表示にされた「後」にこの処理が呼び出されます。
- (void)viewDidDisappear:(BOOL)animated
{
	[super viewDidDisappear:animated];
}

#pragma mark -
#pragma mark M-6.2 ローテーションをイジろうブロック
//------------------------------------------//
// M-6.2 ローテーションをイジろうブロック
//------------------------------------------//

// iPhone/iPadが倒された時にローテーションをサポートするかどうかを設定します。
// YESが返るようにするとその方向に対してローテーションが作動するようになります。
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // iPhoneの場合
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
        return (interfaceOrientation == UIInterfaceOrientationPortrait                  //正しい向き
                //||interfaceOrientation == UIInterfaceOrientationLandscapeLeft         //右に倒した場合
                //||interfaceOrientation == UIInterfaceOrientationLandscapeRight		//左に倒した場合
                //||interfaceOrientation == UIInterfaceOrientationPortraitUpsideDown	//逆さまにした場合
                );
    // iPadの場合
    } else {
        return (interfaceOrientation == UIInterfaceOrientationPortrait                  //正しい向き
                //||interfaceOrientation == UIInterfaceOrientationLandscapeLeft         //右に倒した場合
                //||interfaceOrientation == UIInterfaceOrientationLandscapeRight		//左に倒した場合
                //||interfaceOrientation == UIInterfaceOrientationPortraitUpsideDown	//逆さまにした場合
                );
    }
}

#pragma mark -
#pragma mark M-6.3 メモリー管理をイジろうブロック
//------------------------------------------//
// M-6.3 メモリー管理をイジろうブロック
//------------------------------------------//

// View Controllerに関連付けられているカスタムデータ構造のうち、
// 重要でないものを解放するには、このメソッドを使用します。なんてアップルも言っています。
- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

// インスタンス化したオブジェクトのメモリを解放します。
- (void)viewDidUnload
{
    [super viewDidUnload];
}

//-------------------------------------------------//
// M-7 メソッドファイルおつかれさまでしたブロック
//-------------------------------------------------//
@end
