//----------------------------------------------------------------------------//
//  RankingViewController.h
//  SARURIS
//  Created by Takashi Kawasaki.
//  Creation date    2012/1/27
//  Last update date 2012/5/18
//  Copyright MaiWay Co., Ltd. All rights reserved.
//----------------------------------------------------------------------------//

//-------------------------------------------------//
// H-1 フレームワークをインポートしようブロック
//-------------------------------------------------//
#import <UIKit/UIKit.h>
#import <AVFoundation/AVFoundation.h>
#import <AudioToolbox/AudioServices.h>
#import <iAd/iAd.h>
#import <GameKit/GameKit.h>

#pragma mark -
#pragma mark H-2 クラスとインスタンス変数の宣言をしようブロック
//-------------------------------------------------//
// H-2 クラスとインスタンス変数の宣言をしようブロック
//-------------------------------------------------//
@interface RankingViewController : UIViewController <UITableViewDelegate,UITableViewDataSource,ADBannerViewDelegate,GKLeaderboardViewControllerDelegate>
{
    // このクラスの中で横断的に使用するインスタンス変数を設定します。
    // 背景イメージ
    UIImageView         *bgImgView_;
    
    // テーブル関連
    UITableView         *rankingTableView_;
    NSArray             *rankingListData_;
    
    // ボタン
    IBOutlet UIButton   *backButton_;
    
    // iAd
    ADBannerView        *adView_;
    
    // 各種サウンド
    AVAudioPlayer       *gameAudio_;
    SystemSoundID       gameSound_;
}

#pragma mark -
#pragma mark H-3 アクセサメソッドの宣言をしようブロック
//-------------------------------------------------//
// H-3 アクセサメソッドの宣言をしようブロック
//-------------------------------------------------//
// （アクセサメソッドはここでは不使用）

#pragma mark -
#pragma mark H-4 オリジナルメソッドの宣言をしようブロック
//-------------------------------------------------//
// H-4 オリジナルメソッドの宣言をしようブロック
//-------------------------------------------------//
- (void)configureView;
- (void)playSound:(id)sender;
- (void)showLeader;

//-------------------------------------------------//
// H-5 ヘッダーファイルおつかれさまでしたブロック
//-------------------------------------------------//
@end
