//----------------------------------------------------------------------------//
//  RankingViewController.m
//  SARURIS
//  Created by Takashi Kawasaki.
//  Creation date    2012/1/27
//  Last update date 2012/5/18
//  Copyright MaiWay Co., Ltd. All rights reserved.
//----------------------------------------------------------------------------//

//-------------------------------------------------//
// M-1 ヘッダーファイルをインポートしようブロック
//-------------------------------------------------//
#import "RankingViewController.h"
#import "CONST.h"

#pragma mark -
#pragma mark M-2 クラスとアクセサメソッドの実装をしようブロック
//-------------------------------------------------//
// M-2 クラスとアクセサメソッドの実装をしようブロック
//-------------------------------------------------//

@implementation RankingViewController
// （アクセサメソッドはここでは不使用）

#pragma mark -
#pragma mark M-3 まずはここに処理を書こうブロック
//-------------------------------------------------//
// M-3 まずはここに処理を書こうブロック
//-------------------------------------------------//

- (void)viewDidLoad
{
    [super viewDidLoad];

    // ビューの設定をまとめて行うメソッドを呼び出します。
    [self configureView];
}

#pragma mark -
#pragma mark M-4 ビューを好きなだけイジろうブロック
//-------------------------------------------------//
// M-4 ビューを好きなだけイジろうブロック
//-------------------------------------------------//

- (void)configureView
{
    // ユーザーデフォルトから保存データを読み出します。
    NSUserDefaults *userDefaults    = [NSUserDefaults standardUserDefaults];
    float audioVolume               = [userDefaults floatForKey:@"audioVolume"];
    rankingListData_                = [userDefaults arrayForKey:@"rankingData"];
    
    // iPhone/iPad共通設定その1
    // 戻るボタン（画面の遷移はstoryboardで設定）
    [backButton_ setTitle:@"" forState: UIControlStateNormal];
    [backButton_ addTarget:self action:@selector(playSound:) forControlEvents:UIControlEventTouchUpInside];
    
    // iPhone固有の設定
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPhone){
        // 背景イメージ
        bgImgView_          = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"bg_ranking.png"]];          
        bgImgView_.frame    = CGRectMake(0.0, 0.0, 320.0, 480.0);
        
        // 戻るボタン
        [backButton_ setImage:[UIImage imageNamed:@"btn_rankingback.png"] forState:UIControlStateNormal];
        backButton_.frame   = CGRectMake(0.0, 440.0, 320.0, 40.0);
        
        // テーブル
        rankingTableView_ = [[UITableView alloc]initWithFrame:CGRectMake(0.0, 80.0, 320.0, 361.0) style:UITableViewStylePlain];
        
        // iAd
        adView_ = [[ADBannerView alloc] initWithFrame:CGRectMake(0.0, 480.0, 320.0, 50.0)];
	// iPad固有の設定
    }else {
        // 背景イメージ
        bgImgView_          = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"bg_ranking_ipad.png"]];
        bgImgView_.frame    = CGRectMake(0.0, 0.0, 768.0, 1024.0);
        
        // 戻るボタン
        [backButton_ setImage:[UIImage imageNamed:@"btn_rankingback_ipad.png"] forState:UIControlStateNormal];
        backButton_.frame   = CGRectMake(0.0, 944.0, 768.0, 80.0);
        
        // テーブル
        rankingTableView_ = [[UITableView alloc]initWithFrame:CGRectMake(80.0, 168.0, 608.0, 776.0) style:UITableViewStylePlain];
        
        // iAd
        adView_ = [[ADBannerView alloc] initWithFrame:CGRectMake(0.0, 1024.0, 768.0, 66.0)];
	}
    
    // 背景をビューに加えます。（storyboard上の各ボタンの下に設置）
    [self.view insertSubview:bgImgView_ atIndex:0];
    
    // iPhone/iPad共通設定その2
    // テーブルを設定
    rankingTableView_.backgroundColor   = [UIColor clearColor];
    rankingTableView_.separatorColor    = [UIColor lightGrayColor];
    
    // デリゲートを設定
    [rankingTableView_ setDelegate:self];
    [rankingTableView_ setDataSource:self];
    
    // テーブルのリロード
    [rankingTableView_ reloadData];
    
    // テーブルをビューに加えます。
    [self.view addSubview:rankingTableView_];
    
    // iAdの設定
    adView_.currentContentSizeIdentifier = ADBannerContentSizeIdentifierPortrait;
    adView_.delegate = self;
    
    // iAdをビューに加えます。
    [self.view insertSubview:adView_ atIndex:1];
    
    // ボタン押下時の効果音を準備する
	NSString *soundPath = [[NSBundle mainBundle] pathForResource:@"se_cancel" ofType:@"wav"];
	NSURL *soundUrl = [NSURL fileURLWithPath:soundPath];
    AudioServicesCreateSystemSoundID((__bridge CFURLRef)soundUrl, &gameSound_);
    
    // BGMの再生を準備する（繰り返し設定）
    NSString *audioPath         = [[NSBundle mainBundle] pathForResource:@"bgm_ranking" ofType:@"mp3"];  
    NSURL *audioUrl             = [NSURL fileURLWithPath:audioPath];
    gameAudio_                  = [[AVAudioPlayer alloc] initWithContentsOfURL:audioUrl error:nil]; 
    gameAudio_.currentTime      = 0.0;
    gameAudio_.volume           = audioVolume;
    gameAudio_.numberOfLoops    = -1;  
    [gameAudio_ prepareToPlay];
}

#pragma mark -
#pragma mark M-5 オリジナルメソッドを実装しようブロック
//-------------------------------------------------//
// M-5 オリジナルメソッドを実装しようブロック
//-------------------------------------------------//

// 戻るボタンが押された時のアクションを設定します。
- (void)playSound:(id)sender
{
    // 音を鳴らす
	AudioServicesPlaySystemSound(gameSound_);
}

// ゲームセンター用リーダーボードを表示します。
- (void)showLeader {
    GKLeaderboardViewController *leaderboardController = [[GKLeaderboardViewController alloc] init];
    if(leaderboardController != nil) {
        leaderboardController.leaderboardDelegate = self;
        // リーダーボードの表示
        [self presentModalViewController:leaderboardController animated:YES];
    }
}

#pragma mark -
#pragma mark M-6 デリゲートメソッドをイジろうブロック
//-------------------------------------------------//
// M-6 デリゲートメソッドをイジろうブロック
//-------------------------------------------------//

// 広告読み込みがエラーになったらこの処理が呼ばれます。
- (void)bannerView:(ADBannerView *)banner didFailToReceiveAdWithError:(NSError * )error
{
    // 今回はなにもしない
}

// 広告読み込みが完了（成功）したらこの処理が呼ばれます。
- (void)bannerViewDidLoadAd:(ADBannerView *)banner
{
    // アニメーションの設定
    [UIView animateWithDuration:0.8
                          delay:0.5
                        options:UIViewAnimationOptionCurveEaseIn
                     animations:^{
                         // iPhoneの場合
                         if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPhone){
                             // テーブルのサイズ変更
                             rankingTableView_.frame = CGRectMake(0.0, 80.0, 320.0, 311.0);
                             // バナーを引っ張り入れる
                             adView_.frame           = CGRectMake(0.0, 391.0, 320.0, 50.0);
                        // iPadの場合
                         }else{
                             // テーブルのサイズ変更
                             rankingTableView_.frame = CGRectMake(80.0, 168.0, 608.0, 710.0);
                             // バナーを引っ張り入れる
                             adView_.frame           = CGRectMake(0.0, 880.0, 768.0, 66.0);
                         }
                     }
                     completion:nil
     ];
}

// リーダーボード上で「完了」ボタンを押すとこの処理が呼ばれます。
- (void)leaderboardViewControllerDidFinish:(GKLeaderboardViewController *)viewController
{
    // リーダーボードを隠す
    [self dismissModalViewControllerAnimated:YES];
}

#pragma mark -
#pragma mark M-6.0 テーブルのあれこれをイジろうブロック
//------------------------------------------//
// M-6.0 テーブルのあれこれをイジろうブロック
//------------------------------------------//

// テーブルのセクション数を設定します。
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 3;
}

// テーブルの行数を設定します。
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    NSInteger rowCount = 0;
    
    if (section == 0) {
        rowCount =  [rankingListData_ count];
    }else if(section == 1){
        rowCount = 1;
    }
    return rowCount;
}

// テーブル列の高さを設定します。
- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
	return 40;
}

// 各テーブルセルの見た目を設定します。
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    // 現在のセクション／行番号を取得
	NSInteger row = [indexPath row];
    NSInteger section = [indexPath section];
    
    // セルを種類別に固有化する（ランキング用のセルと、GameCenter行きのセル）
    static const id CellIdentifiers[2] = {@"Rank-cell", @"Game-cell"};
    NSString* CellIdentifier = CellIdentifiers[indexPath.section];
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
	
    if (cell == nil) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier];
    }
    
    // セルの背景色を設定
    cell.backgroundColor = [UIColor clearColor];
    
    if (section == 0){
        
        // 順位イメージを設定
        [cell.imageView setImage:[UIImage imageNamed:[NSString stringWithFormat:@"no%d.png",row+1]]];
        
        // セルの文字の設定
        cell.textLabel.textColor = [UIColor whiteColor];
        cell.textLabel.font = [UIFont boldSystemFontOfSize:26];
        cell.textLabel.shadowColor = [UIColor blackColor];
        cell.textLabel.shadowOffset = CGSizeMake(1, 1);
        cell.textLabel.textAlignment = UITextAlignmentRight;
        
        // 得点ラベルのフォーマットの設定（数字桁切り）
        NSNumberFormatter *formatter=[[NSNumberFormatter alloc] init];
        [formatter setPositiveFormat:@"#,##0"];
        NSString *tempStr = [formatter stringFromNumber:[NSNumber numberWithInt:[[rankingListData_ objectAtIndex:row] intValue]]];
        cell.textLabel.text = [NSString stringWithFormat:@"%@",tempStr];
        
        // セルが選択されたときの選択色をなしに
        cell.selectionStyle = UITableViewCellSelectionStyleNone;
        
    }else if(section == 1){
        
        // セルの文字の設定
        cell.textLabel.textColor = [UIColor whiteColor];
        cell.textLabel.font = [UIFont boldSystemFontOfSize:20];
        cell.textLabel.shadowColor = [UIColor blackColor];
        cell.textLabel.shadowOffset = CGSizeMake(1, 1);
        cell.textLabel.textAlignment = UITextAlignmentCenter;
        
        // セルのラベルの設定
        cell.textLabel.text =  NSLocalizedString(@"View GameCenter", @"");
        
        // セルが選択されたときの選択色をグレーに
        cell.selectionStyle = UITableViewCellSelectionStyleGray;
        
    }
	return cell;
}

// 行の選択開始時の処理を設定します。
- (NSIndexPath *)tableView:(UITableView *)tableView willSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    return indexPath;
}

// 行の選択後の処理を設定します。
- (void)tableView:(UITableView * )tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    // 選択中のセクションを取得
    NSInteger section = [indexPath section];
    
    // GameCenter行きのセルだった場合、リーダーボードを表示
    if (section == 1) {
        [self showLeader];
    }
}

#pragma mark -
#pragma mark M-6.1 ビューのあれこれをイジろうブロック
//------------------------------------------//
// M-6.1 ビューのあれこれをイジろうブロック
//------------------------------------------//

// ビューが表示される「前」にこの処理が呼ばれます。
- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    
    // BGM再生
    [gameAudio_ play];
    
    // テーブルセルの選択色をクリア
    [rankingTableView_ deselectRowAtIndexPath:[rankingTableView_ indexPathForSelectedRow] animated:YES];
}

// ビューが表示された「後」にこの処理が呼ばれます。
- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

// ビューが非表示にされる「前」にこの処理が呼び出されます。
- (void)viewWillDisappear:(BOOL)animated
{
	[super viewWillDisappear:animated];
    
    // 音楽を止めて初期化
    if ([gameAudio_ isPlaying]) {
        [gameAudio_ stop];
        gameAudio_.currentTime = 0.0;
    }
}

// ビューが非表示にされた「後」にこの処理が呼び出されます。
- (void)viewDidDisappear:(BOOL)animated
{
	[super viewDidDisappear:animated];
}

#pragma mark -
#pragma mark M-6.2 ローテーションをイジろうブロック
//------------------------------------------//
// M-6.2 ローテーションをイジろうブロック
//------------------------------------------//

// iPhone/iPadが倒された時にローテーションをサポートするかどうかを設定します。
// YESが返るようにするとその方向に対してローテーションが作動するようになります。
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // iPhoneの場合
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
        return (interfaceOrientation == UIInterfaceOrientationPortrait                  //正しい向き
                //||interfaceOrientation == UIInterfaceOrientationLandscapeLeft         //右に倒した場合
                //||interfaceOrientation == UIInterfaceOrientationLandscapeRight		//左に倒した場合
                //||interfaceOrientation == UIInterfaceOrientationPortraitUpsideDown	//逆さまにした場合
                );
    // iPadの場合
    } else {
        return (interfaceOrientation == UIInterfaceOrientationPortrait                  //正しい向き
                //||interfaceOrientation == UIInterfaceOrientationLandscapeLeft         //右に倒した場合
                //||interfaceOrientation == UIInterfaceOrientationLandscapeRight		//左に倒した場合
                //||interfaceOrientation == UIInterfaceOrientationPortraitUpsideDown	//逆さまにした場合
                );
    }
}

#pragma mark -
#pragma mark M-6.3 メモリー管理をイジろうブロック
//------------------------------------------//
// M-6.3 メモリー管理をイジろうブロック
//------------------------------------------//

// View Controllerに関連付けられているカスタムデータ構造のうち、
// 重要でないものを解放するには、このメソッドを使用します。なんてアップルも言っています。
- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
}

// インスタンス化したオブジェクトのメモリを解放します。
- (void)viewDidUnload
{
    [super viewDidUnload];
}

//-------------------------------------------------//
// M-7 メソッドファイルおつかれさまでしたブロック
//-------------------------------------------------//
@end
