//----------------------------------------------------------------------------//
//  ViewController.m
//  SampleProject
//  Created by Takashi Kawasaki.
//  Creation date    2012/4/4
//  Last update date 2012/4/4
//  Copyright MaiWay Co., Ltd. All rights reserved.
//----------------------------------------------------------------------------//

//-------------------------------------------------//
// M-1 ヘッダーファイルをインポートしようブロック
//-------------------------------------------------//
#import "ViewController.h"

@interface ViewController ()
@end

//-------------------------------------------------//
// M-2 クラスとアクセサメソッドの実装をしようブロック
//-------------------------------------------------//
@implementation ViewController

@synthesize label = label;
@synthesize button = button;
@synthesize webView = webView;

//-------------------------------------------------//
// M-3 まずはここに処理を書こうブロック
//-------------------------------------------------//
- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    
    // ビューの設定をまとめて行うメソッドを呼び出します。
    [self configureView];
}

//-------------------------------------------------//
// M-4 ビューを好きなだけイジろうブロック
//-------------------------------------------------//
- (void)configureView
{
    label = [[UILabel alloc] initWithFrame:CGRectMake(10.0, 20.0, 300.0, 40.0)];
    label.text = @"Hello, world!";
    label.textAlignment = UITextAlignmentCenter;
    [self.view addSubview:label];
    
    button = [UIButton buttonWithType:UIButtonTypeRoundedRect];
    button.frame = CGRectMake(40.0, 80.0, 240.0, 40.0);
    [button setTitle:@"Touch!" forState:UIControlStateNormal];
    [button addTarget:self action:@selector(action) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:button];
        
    webView = [[UIWebView alloc] initWithFrame:CGRectMake(10.0, 160.0, 300.0, 280.0)];
	webView.scalesPageToFit = YES;
	webView.delegate = self;
	[self.view addSubview:webView];
}

//-------------------------------------------------//
// M-5 オリジナルメソッドを実装しようブロック
//-------------------------------------------------//
- (void)action
{
    [webView loadRequest:[NSURLRequest requestWithURL:[NSURL URLWithString:@"http://ja.wikipedia.org/wiki/Hello_world"]]];
}

//-------------------------------------------------//
// M-6 デリゲートメソッドをイジろうブロック
//-------------------------------------------------//
- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}

- (void)webViewDidStartLoad:(UIWebView *)webView
{
	[UIApplication sharedApplication].networkActivityIndicatorVisible = YES;
}
- (void)webViewDidFinishLoad:(UIWebView *)webView
{
	[UIApplication sharedApplication].networkActivityIndicatorVisible = NO;
}
- (void)webView:(UIWebView *)webView didFailLoadWithError:(NSError *)error
{
	[UIApplication sharedApplication].networkActivityIndicatorVisible = NO;
}

//-------------------------------------------------//
// M-7 メソッドファイルおつかれさまでしたブロック
//-------------------------------------------------//
@end
