//----------------------------------------------------------------------------//
//  ViewController.m
//  SampleProject
//  Created by Takashi Kawasaki.
//  Creation date    2012/4/4
//  Last update date 2012/4/4
//  Copyright MaiWay Co., Ltd. All rights reserved.
//----------------------------------------------------------------------------//

//-------------------------------------------------//
// M-1 ヘッダーファイルをインポートしようブロック
//-------------------------------------------------//
#import "ViewController.h"

@interface ViewController ()
@end

//-------------------------------------------------//
// M-2 クラスとアクセサメソッドの実装をしようブロック
//-------------------------------------------------//
@implementation ViewController

//-------------------------------------------------//
// M-3 まずはここに処理を書こうブロック
//-------------------------------------------------//
- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    
    // ビューの設定をまとめて行うメソッドを呼び出します。
    [self configureView];
}

//-------------------------------------------------//
// M-4 ビューを好きなだけイジろうブロック
//-------------------------------------------------//
- (void)configureView
{
	UIScrollView *customScrollView = [[UIScrollView alloc] initWithFrame:CGRectMake(10.0, 10.0, 300.0, 300.0)];
	customScrollView.contentSize = CGSizeMake(400.0, 400.0);
	customScrollView.pagingEnabled = YES;
	customScrollView.bounces = YES;
	customScrollView.showsHorizontalScrollIndicator = YES;
	customScrollView.showsVerticalScrollIndicator = YES;
	customScrollView.scrollsToTop = YES;
	customScrollView.maximumZoomScale = 4.0;
	customScrollView.minimumZoomScale = 0.5;
	customScrollView.delegate = self;
	[self.view addSubview:customScrollView];
	
    customImageView = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"Sample.png"]];
	customImageView.frame = CGRectMake(0.0, 0.0, 300.0, 300.0);
	[customScrollView addSubview:customImageView];
}

//-------------------------------------------------//
// M-5 オリジナルメソッドを実装しようブロック
//-------------------------------------------------//

//-------------------------------------------------//
// M-6 デリゲートメソッドをイジろうブロック
//-------------------------------------------------//
- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}

- (UIView *)viewForZoomingInScrollView:(UIScrollView *)scrollView {
	return customImageView;
}

- (void)scrollViewDidScroll:(UIScrollView *)scrollView {
    NSLog(@"ビューがスクロール・ズームしています！");
}

//-------------------------------------------------//
// M-7 メソッドファイルおつかれさまでしたブロック
//-------------------------------------------------//
@end
