//----------------------------------------------------------------------------//
//  ViewController.m
//  SampleProject
//  Created by Takashi Kawasaki.
//  Creation date    2012/4/4
//  Last update date 2012/4/4
//  Copyright MaiWay Co., Ltd. All rights reserved.
//----------------------------------------------------------------------------//

//-------------------------------------------------//
// M-1 ヘッダーファイルをインポートしようブロック
//-------------------------------------------------//
#import "ViewController.h"

@interface ViewController ()
@end

//-------------------------------------------------//
// M-2 クラスとアクセサメソッドの実装をしようブロック
//-------------------------------------------------//
@implementation ViewController

//-------------------------------------------------//
// M-3 まずはここに処理を書こうブロック
//-------------------------------------------------//
- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    
    // ビューの設定をまとめて行うメソッドを呼び出します。
    [self configureView];
}

//-------------------------------------------------//
// M-4 ビューを好きなだけイジろうブロック
//-------------------------------------------------//
- (void)configureView
{
    UISlider *customSlider = [[UISlider alloc] initWithFrame:CGRectMake(40.0, 160.0, 240.0, 40.0)];
    customSlider.minimumValue = 0.0;
    customSlider.maximumValue = 100.0;
    customSlider.value = 50.0;
    [customSlider addTarget:self action:@selector(action:) forControlEvents:UIControlEventValueChanged];
    customSlider.continuous = YES;
    [customSlider setThumbImage: [UIImage imageNamed:@"SampleIcon.png"] forState:UIControlStateNormal];
    [customSlider setThumbImage: [UIImage imageNamed:@"SampleIcon.png"] forState:UIControlStateHighlighted];
    [customSlider setMinimumTrackImage:[UIImage imageNamed:@"leftTrack.png"] forState:UIControlStateNormal];
    [customSlider setMaximumTrackImage:[UIImage imageNamed:@"rightTrack.png"]  forState:UIControlStateNormal];
    [self.view addSubview:customSlider];
}

//-------------------------------------------------//
// M-5 オリジナルメソッドを実装しようブロック
//-------------------------------------------------//
- (void)action:(id)sender
{
    UISlider *tempSlider = sender;
    NSLog(@"スライダーの値は『%f』です！",tempSlider.value);
}

//-------------------------------------------------//
// M-6 デリゲートメソッドをイジろうブロック
//-------------------------------------------------//
- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}

//-------------------------------------------------//
// M-7 メソッドファイルおつかれさまでしたブロック
//-------------------------------------------------//
@end
