//----------------------------------------------------------------------------//
//  ViewController.m
//  SampleProject
//  Created by Takashi Kawasaki.
//  Creation date    2012/4/4
//  Last update date 2012/4/4
//  Copyright MaiWay Co., Ltd. All rights reserved.
//----------------------------------------------------------------------------//

//-------------------------------------------------//
// M-1 ヘッダーファイルをインポートしようブロック
//-------------------------------------------------//
#import "ViewController.h"

@interface ViewController ()
@end

//-------------------------------------------------//
// M-2 クラスとアクセサメソッドの実装をしようブロック
//-------------------------------------------------//
@implementation ViewController

//-------------------------------------------------//
// M-3 まずはここに処理を書こうブロック
//-------------------------------------------------//
- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    
    // ビューの設定をまとめて行うメソッドを呼び出します。
    [self configureView];
}

//-------------------------------------------------//
// M-4 ビューを好きなだけイジろうブロック
//-------------------------------------------------//
- (void)configureView
{
	UITextField *customTextField = [[UITextField alloc] initWithFrame:CGRectMake(10.0, 100.0, 300.0, 40.0)];
	customTextField.borderStyle = UITextBorderStyleRoundedRect;
	customTextField.font = [UIFont systemFontOfSize:20.0];
	customTextField.textColor = [UIColor blackColor];
	customTextField.textAlignment = UITextAlignmentLeft;
    customTextField.contentVerticalAlignment = UIControlContentVerticalAlignmentCenter;
	customTextField.backgroundColor = [UIColor whiteColor];
	customTextField.placeholder = @"ここに入力してください";
	customTextField.autocorrectionType = UITextAutocorrectionTypeNo;
	customTextField.autocapitalizationType = UITextAutocapitalizationTypeNone;
	customTextField.keyboardType = UIKeyboardTypeDefault;
	customTextField.returnKeyType = UIReturnKeyDone;
	customTextField.clearButtonMode = UITextFieldViewModeWhileEditing;
	customTextField.delegate = self;
	[customTextField addTarget:self action:@selector(action:) forControlEvents:UIControlEventEditingDidEnd];
    
	[self.view addSubview:customTextField];
}

//-------------------------------------------------//
// M-5 オリジナルメソッドを実装しようブロック
//-------------------------------------------------//
- (void)action:(id)sender
{
    UITextField *tempTextField = sender;
    NSLog(@"入力された文字は『%@』です！",tempTextField.text);
}

//-------------------------------------------------//
// M-6 デリゲートメソッドをイジろうブロック
//-------------------------------------------------//
- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}

- (BOOL)textFieldShouldReturn:(UITextField *)textField
{
	[textField resignFirstResponder];
	return YES;
}

//-------------------------------------------------//
// M-7 メソッドファイルおつかれさまでしたブロック
//-------------------------------------------------//
@end
