//----------------------------------------------------------------------------//
//  ViewController.m
//  SampleProject
//  Created by Takashi Kawasaki.
//  Creation date    2012/4/4
//  Last update date 2012/4/4
//  Copyright MaiWay Co., Ltd. All rights reserved.
//----------------------------------------------------------------------------//

//-------------------------------------------------//
// M-1 ヘッダーファイルをインポートしようブロック
//-------------------------------------------------//
#import "ViewController.h"

@interface ViewController ()
@end

//-------------------------------------------------//
// M-2 クラスとアクセサメソッドの実装をしようブロック
//-------------------------------------------------//
@implementation ViewController

//-------------------------------------------------//
// M-3 まずはここに処理を書こうブロック
//-------------------------------------------------//
- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    
    // ビューの設定をまとめて行うメソッドを呼び出します。
    [self configureView];
}

//-------------------------------------------------//
// M-4 ビューを好きなだけイジろうブロック
//-------------------------------------------------//
- (void)configureView
{
	pickerViewData = [NSArray arrayWithObjects:
                      @"マイキー", @"サリー", @"マックス", @"ピッポ", @"レオ", @"ナッチ", @"ネッティー", @"ハッピー",
                      nil];
    
	UIPickerView *customPickerView = [[UIPickerView alloc] initWithFrame:CGRectMake(0.0, 10.0, 0.0, 0.0)];
	customPickerView.showsSelectionIndicator = YES;	
	customPickerView.delegate = self; 
	[self.view addSubview:customPickerView];
	
	UIDatePicker *customDatePicker = [[UIDatePicker alloc] initWithFrame:CGRectMake(0.0, 236.0, 0.0, 0.0)];
	customDatePicker.datePickerMode = UIDatePickerModeDateAndTime;
	NSDate *today = [NSDate date];
	customDatePicker.date = today;
	[self.view addSubview:customDatePicker];
}

//-------------------------------------------------//
// M-5 オリジナルメソッドを実装しようブロック
//-------------------------------------------------//

//-------------------------------------------------//
// M-6 デリゲートメソッドをイジろうブロック
//-------------------------------------------------//
- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}

- (NSInteger)numberOfComponentsInPickerView:(UIPickerView *)pickerView
{
	return 2;
}

- (NSInteger)pickerView:(UIPickerView *)pickerView numberOfRowsInComponent:(NSInteger)component
{
	return [pickerViewData count];
}

- (CGFloat)pickerView:(UIPickerView *)pickerView rowHeightForComponent:(NSInteger)component
{
	return 40.0;
}

- (CGFloat)pickerView:(UIPickerView *)pickerView widthForComponent:(NSInteger)component
{
	CGFloat width = 0.0;
	switch (component) {
		case 0: {
			width = 50.0;
			break;
		}
        case 1: {
			width = 250.0;
			break;
		}
	}
	return width;
}

- (NSString *)pickerView:(UIPickerView *)pickerView titleForRow:(NSInteger)row forComponent:(NSInteger)component
{
	NSString *string = @"";
    switch (component) {
        case 0: {
            string = [NSString stringWithFormat:@"%d", row];
            break;
        }
        case 1: {
            string = [pickerViewData objectAtIndex:row];
            break;
        }
    }	
	return string;
}

//-------------------------------------------------//
// M-7 メソッドファイルおつかれさまでしたブロック
//-------------------------------------------------//
@end
