//----------------------------------------------------------------------------//
//  ViewController.m
//  SampleProject
//  Created by Takashi Kawasaki.
//  Creation date    2012/4/4
//  Last update date 2012/4/4
//  Copyright MaiWay Co., Ltd. All rights reserved.
//----------------------------------------------------------------------------//

//-------------------------------------------------//
// M-1 ヘッダーファイルをインポートしようブロック
//-------------------------------------------------//
#import "ViewController.h"

@interface ViewController ()
@end

//-------------------------------------------------//
// M-2 クラスとアクセサメソッドの実装をしようブロック
//-------------------------------------------------//
@implementation ViewController

//-------------------------------------------------//
// M-3 まずはここに処理を書こうブロック
//-------------------------------------------------//
- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    
    // ビューの設定をまとめて行うメソッドを呼び出します。
    [self configureView];
}

//-------------------------------------------------//
// M-4 ビューを好きなだけイジろうブロック
//-------------------------------------------------//
- (void)configureView
{
    customImageView1 = [[UIImageView alloc] initWithFrame:CGRectMake(10.0, 10.0, 300.0, 300.0)];
    customImageView2 = [[UIImageView alloc] initWithFrame:CGRectMake(10.0, 10.0, 300.0, 300.0)];
    customImageView1.backgroundColor = [UIColor blueColor];
    customImageView2.backgroundColor = [UIColor redColor];
	[self.view addSubview:customImageView1];
    customImageView1.hidden = YES;
    [self.view addSubview:customImageView2];
    customImageView2.hidden = NO;
    
    UIButton *customButton = [UIButton buttonWithType:UIButtonTypeRoundedRect];
    customButton.frame = CGRectMake(40.0, 340.0, 240.0, 40.0);
    [customButton setTitle:@"回転" forState:UIControlStateNormal];
    customButton.reversesTitleShadowWhenHighlighted = YES;
    [customButton addTarget:self action:@selector(action) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:customButton];
}

//-------------------------------------------------//
// M-5 オリジナルメソッドを実装しようブロック
//-------------------------------------------------//
- (void)action
{
    if(customImageView1.hidden){
        [UIView transitionWithView:self.view
                          duration:1.0
                           options:UIViewAnimationOptionTransitionFlipFromLeft
                        animations:^{
                            customImageView1.hidden = NO;
                            customImageView2.hidden = YES;
                        }
                        completion:NULL];
    }else{
        [UIView transitionWithView:self.view
                          duration:1.0
                           options:UIViewAnimationOptionTransitionFlipFromLeft
                        animations:^{
                            customImageView1.hidden = YES;
                            customImageView2.hidden = NO;
                        }
                        completion:NULL];
    }
}

//-------------------------------------------------//
// M-6 デリゲートメソッドをイジろうブロック
//-------------------------------------------------//
- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}

//-------------------------------------------------//
// M-7 メソッドファイルおつかれさまでしたブロック
//-------------------------------------------------//
@end
