//----------------------------------------------------------------------------//
//  ViewController.m
//  SampleProject
//  Created by Takashi Kawasaki.
//  Creation date    2012/4/4
//  Last update date 2012/4/4
//  Copyright MaiWay Co., Ltd. All rights reserved.
//----------------------------------------------------------------------------//

//-------------------------------------------------//
// M-1 ヘッダーファイルをインポートしようブロック
//-------------------------------------------------//
#import "ViewController.h"

@interface ViewController ()
@end

//-------------------------------------------------//
// M-2 クラスとアクセサメソッドの実装をしようブロック
//-------------------------------------------------//
@implementation ViewController

//-------------------------------------------------//
// M-3 まずはここに処理を書こうブロック
//-------------------------------------------------//
- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    
    // ビューの設定をまとめて行うメソッドを呼び出します。
    [self configureView];
}

//-------------------------------------------------//
// M-4 ビューを好きなだけイジろうブロック
//-------------------------------------------------//
- (void)configureView
{
    UIButton *customButton1 = [UIButton buttonWithType:UIButtonTypeRoundedRect];
    customButton1.frame = CGRectMake(40.0, 160.0, 240.0, 40.0);
    [customButton1 setTitle:@"カメラ" forState:UIControlStateNormal];
    [customButton1 addTarget:self action:@selector(showCamera) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:customButton1];
	
    UIButton *customButton2 = [UIButton buttonWithType:UIButtonTypeRoundedRect];
	customButton2.frame = CGRectMake(40.0, 260.0, 240.0, 40.0);
    [customButton2 setTitle:@"アルバム" forState:UIControlStateNormal];
    [customButton2 addTarget:self action:@selector(showPhotoLibrary) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:customButton2];
    
    customImageView = [[UIImageView alloc] initWithFrame:CGRectMake(10.0, 140.0, 300.0, 300.0)];
    [self.view addSubview:customImageView];
}

//-------------------------------------------------//
// M-5 オリジナルメソッドを実装しようブロック
//-------------------------------------------------//
- (void)showCamera
{
    UIImagePickerControllerSourceType sourceType = UIImagePickerControllerSourceTypeCamera;
    if (![UIImagePickerController isSourceTypeAvailable:sourceType]) {  
        return;
    }
    UIImagePickerController* imagePicker = [[UIImagePickerController alloc] init];
    imagePicker.sourceType = sourceType;
    imagePicker.delegate = self;	
    [self presentModalViewController:imagePicker animated:YES];
}

- (void)showPhotoLibrary
{
    UIImagePickerControllerSourceType sourceType = UIImagePickerControllerSourceTypePhotoLibrary;
    if (![UIImagePickerController isSourceTypeAvailable:sourceType]) {  
        return;
    }
    UIImagePickerController* imagePicker = [[UIImagePickerController alloc] init];
    imagePicker.sourceType = sourceType;
    imagePicker.delegate = self;	
    [self presentModalViewController:imagePicker animated:YES];
}

//-------------------------------------------------//
// M-6 デリゲートメソッドをイジろうブロック
//-------------------------------------------------//
- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}

- (void)imagePickerController:(UIImagePickerController*)picker didFinishPickingMediaWithInfo:(NSDictionary*)info {
	[self dismissModalViewControllerAnimated:YES];	
	UIImage* originalImage = [info objectForKey:UIImagePickerControllerOriginalImage];
	customImageView.image = originalImage;
	UIImageWriteToSavedPhotosAlbum(originalImage, nil, nil, nil);
}

- (void)imagePickerControllerDidCancel:(UIImagePickerController*)picker
{
    [self dismissModalViewControllerAnimated:YES];
}

//-------------------------------------------------//
// M-7 メソッドファイルおつかれさまでしたブロック
//-------------------------------------------------//
@end
