//----------------------------------------------------------------------------//
//  ViewController.m
//  SampleProject
//  Created by Takashi Kawasaki.
//  Creation date    2012/4/4
//  Last update date 2012/4/4
//  Copyright MaiWay Co., Ltd. All rights reserved.
//----------------------------------------------------------------------------//

//-------------------------------------------------//
// M-1 ヘッダーファイルをインポートしようブロック
//-------------------------------------------------//
#import "ViewController.h"

@interface ViewController ()
@end

//-------------------------------------------------//
// M-2 クラスとアクセサメソッドの実装をしようブロック
//-------------------------------------------------//
@implementation ViewController

//-------------------------------------------------//
// M-3 まずはここに処理を書こうブロック
//-------------------------------------------------//
- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    
    // ビューの設定をまとめて行うメソッドを呼び出します。
    [self configureView];
}

//-------------------------------------------------//
// M-4 ビューを好きなだけイジろうブロック
//-------------------------------------------------//
- (void)configureView
{
    UIButton *customButton1 = [UIButton buttonWithType:UIButtonTypeRoundedRect];
    customButton1.frame = CGRectMake(40.0, 160.0, 240.0, 40.0);
    [customButton1 setTitle:@"曲を選択" forState:UIControlStateNormal];
    [customButton1 addTarget:self action:@selector(selectMusic) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:customButton1];
	
    UIButton *customButton2 = [UIButton buttonWithType:UIButtonTypeRoundedRect];
	customButton2.frame = CGRectMake(40.0, 260.0, 240.0, 40.0);
    [customButton2 setTitle:@"曲を再生" forState:UIControlStateNormal];
    [customButton2 addTarget:self action:@selector(playMusic) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:customButton2];
}

//-------------------------------------------------//
// M-5 オリジナルメソッドを実装しようブロック
//-------------------------------------------------//
- (void)selectMusic
{
    MPMediaPickerController *mediaPicker = [[MPMediaPickerController alloc] init];
    mediaPicker.allowsPickingMultipleItems = NO;
    mediaPicker.delegate = self;    
    [self presentModalViewController:mediaPicker animated: YES];
}

- (void)playMusic
{
    MPMediaQuery *query = [[MPMediaQuery alloc] init];
    [query addFilterPredicate: [MPMediaPropertyPredicate predicateWithValue:musicTitle forProperty: MPMediaItemPropertyTitle]];
    MPMusicPlayerController *musicPlayer = [[MPMusicPlayerController alloc] init];
    musicPlayer = [MPMusicPlayerController applicationMusicPlayer];
    musicPlayer.repeatMode = MPMusicRepeatModeOne;
	musicPlayer.shuffleMode = MPMusicShuffleModeOff;
    [musicPlayer setQueueWithQuery:query];
    [musicPlayer play];
}

//-------------------------------------------------//
// M-6 デリゲートメソッドをイジろうブロック
//-------------------------------------------------//
- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}

- (void)mediaPicker: (MPMediaPickerController *) mediaPicker didPickMediaItems: (MPMediaItemCollection *) mediaItemCollection
{
    [self dismissModalViewControllerAnimated: YES];
    userMediaItemCollection = mediaItemCollection;
    MPMediaItem *representativeItem = [userMediaItemCollection representativeItem];
    musicTitle = [representativeItem valueForProperty: MPMediaItemPropertyTitle];
}

- (void)mediaPickerDidCancel:(MPMediaPickerController *)mediaPicker
{
	[self dismissModalViewControllerAnimated:YES];
}

//-------------------------------------------------//
// M-7 メソッドファイルおつかれさまでしたブロック
//-------------------------------------------------//
@end
